All of lore.kernel.org
 help / color / mirror / Atom feed
* [PATCH v8 0/2] Basic early_printk and smoke test implementation
@ 2023-01-31 11:17 Oleksii Kurochko
  2023-01-31 11:17 ` [PATCH v8 1/2] xen/riscv: introduce early_printk basic stuff Oleksii Kurochko
  2023-01-31 11:17 ` [PATCH v8 2/2] automation: update RISC-V smoke test Oleksii Kurochko
  0 siblings, 2 replies; 6+ messages in thread
From: Oleksii Kurochko @ 2023-01-31 11:17 UTC (permalink / raw)
  To: xen-devel
  Cc: Jan Beulich, Julien Grall, Andrew Cooper, Stefano Stabellini,
	Gianluca Guida, Oleksii Kurochko, Bob Eshleman, Alistair Francis,
	Connor Davis, Doug Goldstein

The patch series introduces the following:
- the minimal set of headers and changes inside them.
- SBI (RISC-V Supervisor Binary Interface) things necessary for basic
  early_printk implementation.
- things needed to set up the stack.
- early_printk() function to print only strings.
- RISC-V smoke test which checks if  "Hello from C env" message is
  present in serial.tmp

The patch series is rebased on top of the patch "include/types: move
stddef.h-kind types to common header" [1]

[1] https://lore.kernel.org/xen-devel/5a0a9e2a-c116-21b5-8081-db75fe4178d7@suse.com/

---
Changes in V8:
 - Set "needs: archlinux-current-gcc-riscv64-debug" in test.yaml
   for RISCV job as CONFIG_EARLY_PRINTK is available only when
   CONFIG_DEBUG is available.
---
Changes in V7:
 - Fix dependecy for qemu-smoke-riscv64-gcc job
---
Changes in V6:
 - Rename container name in test.yaml for .qemu-riscv64.
---
Changes in V5:
  - Nothing changed
---
Changes in V4:
  - Nothing changed
---
Changes in V3:
  - Nothing changed
  - All mentioned comments by Stefano in Xen mailing list will be
    fixed as a separate patch out of this patch series.
---

Oleksii Kurochko (2):
  xen/riscv: introduce early_printk basic stuff
  automation: add RISC-V smoke test

 automation/gitlab-ci/test.yaml            | 20 ++++++++++++++
 automation/scripts/qemu-smoke-riscv64.sh  | 20 ++++++++++++++
 xen/arch/riscv/Kconfig.debug              |  5 ++++
 xen/arch/riscv/Makefile                   |  1 +
 xen/arch/riscv/early_printk.c             | 33 +++++++++++++++++++++++
 xen/arch/riscv/include/asm/early_printk.h | 12 +++++++++
 xen/arch/riscv/setup.c                    |  4 +++
 7 files changed, 95 insertions(+)
 create mode 100755 automation/scripts/qemu-smoke-riscv64.sh
 create mode 100644 xen/arch/riscv/early_printk.c
 create mode 100644 xen/arch/riscv/include/asm/early_printk.h

-- 
2.39.0



^ permalink raw reply	[flat|nested] 6+ messages in thread

* [PATCH v8 1/2] xen/riscv: introduce early_printk basic stuff
  2023-01-31 11:17 [PATCH v8 0/2] Basic early_printk and smoke test implementation Oleksii Kurochko
@ 2023-01-31 11:17 ` Oleksii Kurochko
  2023-01-31 11:42   ` Julien Grall
  2023-01-31 11:17 ` [PATCH v8 2/2] automation: update RISC-V smoke test Oleksii Kurochko
  1 sibling, 1 reply; 6+ messages in thread
From: Oleksii Kurochko @ 2023-01-31 11:17 UTC (permalink / raw)
  To: xen-devel
  Cc: Jan Beulich, Julien Grall, Andrew Cooper, Stefano Stabellini,
	Gianluca Guida, Oleksii Kurochko, Bob Eshleman, Alistair Francis,
	Connor Davis, Bobby Eshleman

Because printk() relies on a serial driver (like the ns16550 driver)
and drivers require working virtual memory (ioremap()) there is not
print functionality early in Xen boot.

The patch introduces the basic stuff of early_printk functionality
which will be enough to print 'hello from C environment".

Originally early_printk.{c,h} was introduced by Bobby Eshleman
(https://github.com/glg-rv/xen/commit/a3c9916bbdff7ad6030055bbee7e53d1aab71384)
but some functionality was changed:
early_printk() function was changed in comparison with the original as
common isn't being built now so there is no vscnprintf.

This commit adds early printk implementation built on the putc SBI call.

As sbi_console_putchar() is already being planned for deprecation
it is used temporarily now and will be removed or reworked after
real uart will be ready.

Signed-off-by: Bobby Eshleman <bobby.eshleman@gmail.com>
Signed-off-by: Oleksii Kurochko <oleksii.kurochko@gmail.com>
Reviewed-by: Bobby Eshleman <bobby.eshleman@gmail.com>
---
Changes in V8:
    - Nothing was changed
---
Changes in V7:
    - Nothing was changed
---
Changes in V6:
    - Remove __riscv_cmodel_medany check from early_printk.c
---
Changes in V5:
    - Code style fixes
    - Change an error message of #error in case of __riscv_cmodel_medany
      isn't defined
---
Changes in V4:
    - Remove "depends on RISCV*" from Kconfig.debug as it is located in
      arch specific folder so by default RISCV configs should be ebabled.
    - Add "ifdef __riscv_cmodel_medany" to be sure that PC-relative addressing
      is used as early_*() functions can be called from head.S with MMU-off and
      before relocation (if it would be needed at all for RISC-V)
    - fix code style
---
Changes in V3:
    - reorder headers in alphabetical order
    - merge changes related to start_xen() function from "[PATCH v2 7/8]
      xen/riscv: print hello message from C env" to this patch
    - remove unneeded parentheses in definition of STACK_SIZE
---
Changes in V2:
    - introduce STACK_SIZE define.
    - use consistent padding between instruction mnemonic and operand(s)
---
 xen/arch/riscv/Kconfig.debug              |  5 ++++
 xen/arch/riscv/Makefile                   |  1 +
 xen/arch/riscv/early_printk.c             | 33 +++++++++++++++++++++++
 xen/arch/riscv/include/asm/early_printk.h | 12 +++++++++
 xen/arch/riscv/setup.c                    |  4 +++
 5 files changed, 55 insertions(+)
 create mode 100644 xen/arch/riscv/early_printk.c
 create mode 100644 xen/arch/riscv/include/asm/early_printk.h

diff --git a/xen/arch/riscv/Kconfig.debug b/xen/arch/riscv/Kconfig.debug
index e69de29bb2..608c9ff832 100644
--- a/xen/arch/riscv/Kconfig.debug
+++ b/xen/arch/riscv/Kconfig.debug
@@ -0,0 +1,5 @@
+config EARLY_PRINTK
+    bool "Enable early printk"
+    default DEBUG
+    help
+      Enables early printk debug messages
diff --git a/xen/arch/riscv/Makefile b/xen/arch/riscv/Makefile
index fd916e1004..1a4f1a6015 100644
--- a/xen/arch/riscv/Makefile
+++ b/xen/arch/riscv/Makefile
@@ -1,3 +1,4 @@
+obj-$(CONFIG_EARLY_PRINTK) += early_printk.o
 obj-$(CONFIG_RISCV_64) += riscv64/
 obj-y += sbi.o
 obj-y += setup.o
diff --git a/xen/arch/riscv/early_printk.c b/xen/arch/riscv/early_printk.c
new file mode 100644
index 0000000000..b66a11f1bc
--- /dev/null
+++ b/xen/arch/riscv/early_printk.c
@@ -0,0 +1,33 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+/*
+ * RISC-V early printk using SBI
+ *
+ * Copyright (C) 2021 Bobby Eshleman <bobbyeshleman@gmail.com>
+ */
+#include <asm/early_printk.h>
+#include <asm/sbi.h>
+
+/*
+ * TODO:
+ *   sbi_console_putchar is already planned for deprecation
+ *   so it should be reworked to use UART directly.
+*/
+void early_puts(const char *s, size_t nr)
+{
+    while ( nr-- > 0 )
+    {
+        if ( *s == '\n' )
+            sbi_console_putchar('\r');
+        sbi_console_putchar(*s);
+        s++;
+    }
+}
+
+void early_printk(const char *str)
+{
+    while ( *str )
+    {
+        early_puts(str, 1);
+        str++;
+    }
+}
diff --git a/xen/arch/riscv/include/asm/early_printk.h b/xen/arch/riscv/include/asm/early_printk.h
new file mode 100644
index 0000000000..05106e160d
--- /dev/null
+++ b/xen/arch/riscv/include/asm/early_printk.h
@@ -0,0 +1,12 @@
+#ifndef __EARLY_PRINTK_H__
+#define __EARLY_PRINTK_H__
+
+#include <xen/early_printk.h>
+
+#ifdef CONFIG_EARLY_PRINTK
+void early_printk(const char *str);
+#else
+static inline void early_printk(const char *s) {};
+#endif
+
+#endif /* __EARLY_PRINTK_H__ */
diff --git a/xen/arch/riscv/setup.c b/xen/arch/riscv/setup.c
index 13e24e2fe1..d09ffe1454 100644
--- a/xen/arch/riscv/setup.c
+++ b/xen/arch/riscv/setup.c
@@ -1,12 +1,16 @@
 #include <xen/compile.h>
 #include <xen/init.h>
 
+#include <asm/early_printk.h>
+
 /* Xen stack for bringing up the first CPU. */
 unsigned char __initdata cpu0_boot_stack[STACK_SIZE]
     __aligned(STACK_SIZE);
 
 void __init noreturn start_xen(void)
 {
+    early_printk("Hello from C env\n");
+
     for ( ;; )
         asm volatile ("wfi");
 
-- 
2.39.0



^ permalink raw reply related	[flat|nested] 6+ messages in thread

* [PATCH v8 2/2] automation: update RISC-V smoke test
  2023-01-31 11:17 [PATCH v8 0/2] Basic early_printk and smoke test implementation Oleksii Kurochko
  2023-01-31 11:17 ` [PATCH v8 1/2] xen/riscv: introduce early_printk basic stuff Oleksii Kurochko
@ 2023-01-31 11:17 ` Oleksii Kurochko
  1 sibling, 0 replies; 6+ messages in thread
From: Oleksii Kurochko @ 2023-01-31 11:17 UTC (permalink / raw)
  To: xen-devel
  Cc: Jan Beulich, Julien Grall, Andrew Cooper, Stefano Stabellini,
	Gianluca Guida, Oleksii Kurochko, Doug Goldstein,
	Alistair Francis

Add check if there is a message 'Hello from C env' presents
in log file to be sure that stack is set and C part of early printk
is working.

Signed-off-by: Oleksii Kurochko <oleksii.kurochko@gmail.com>
Acked-by: Stefano Stabellini <sstabellini@kernel.org>
Reviewed-by: Alistair Francis <alistair.francis@wdc.com>
---
Changes in V8:
 - Set "needs: archlinux-current-gcc-riscv64-debug" in test.yaml
   for RISCV job as CONFIG_EARLY_PRINTK is available only when
   CONFIG_DEBUG is available.
---
Changes in V7:
 - Fix dependecy for qemu-smoke-riscv64-gcc job
---
Changes in V6:
 - Rename container name in test.yaml for .qemu-riscv64.
---
Changes in V5:
  - Nothing changed
---
Changes in V4:
  - Nothing changed
---
Changes in V3:
  - Nothing changed
  - All mentioned comments by Stefano in Xen mailing list will be
    fixed as a separate patch out of this patch series.
---
 automation/gitlab-ci/test.yaml           | 20 ++++++++++++++++++++
 automation/scripts/qemu-smoke-riscv64.sh | 20 ++++++++++++++++++++
 2 files changed, 40 insertions(+)
 create mode 100755 automation/scripts/qemu-smoke-riscv64.sh

diff --git a/automation/gitlab-ci/test.yaml b/automation/gitlab-ci/test.yaml
index afd80adfe1..ce543ef5c0 100644
--- a/automation/gitlab-ci/test.yaml
+++ b/automation/gitlab-ci/test.yaml
@@ -54,6 +54,19 @@
   tags:
     - x86_64
 
+.qemu-riscv64:
+  extends: .test-jobs-common
+  variables:
+    CONTAINER: archlinux:current-riscv64
+    LOGFILE: qemu-smoke-riscv64.log
+  artifacts:
+    paths:
+      - smoke.serial
+      - '*.log'
+    when: always
+  tags:
+    - x86_64
+
 .yocto-test:
   extends: .test-jobs-common
   script:
@@ -234,6 +247,13 @@ qemu-smoke-x86-64-clang-pvh:
   needs:
     - debian-unstable-clang-debug
 
+qemu-smoke-riscv64-gcc:
+  extends: .qemu-riscv64
+  script:
+    - ./automation/scripts/qemu-smoke-riscv64.sh 2>&1 | tee ${LOGFILE}
+  needs:
+    - archlinux-current-gcc-riscv64-debug
+
 # Yocto test jobs
 yocto-qemuarm64:
   extends: .yocto-test-arm64
diff --git a/automation/scripts/qemu-smoke-riscv64.sh b/automation/scripts/qemu-smoke-riscv64.sh
new file mode 100755
index 0000000000..e0f06360bc
--- /dev/null
+++ b/automation/scripts/qemu-smoke-riscv64.sh
@@ -0,0 +1,20 @@
+#!/bin/bash
+
+set -ex
+
+# Run the test
+rm -f smoke.serial
+set +e
+
+timeout -k 1 2 \
+qemu-system-riscv64 \
+    -M virt \
+    -smp 1 \
+    -nographic \
+    -m 2g \
+    -kernel binaries/xen \
+    |& tee smoke.serial
+
+set -e
+(grep -q "Hello from C env" smoke.serial) || exit 1
+exit 0
-- 
2.39.0



^ permalink raw reply related	[flat|nested] 6+ messages in thread

* Re: [PATCH v8 1/2] xen/riscv: introduce early_printk basic stuff
  2023-01-31 11:17 ` [PATCH v8 1/2] xen/riscv: introduce early_printk basic stuff Oleksii Kurochko
@ 2023-01-31 11:42   ` Julien Grall
  2023-01-31 12:37     ` Oleksii
  0 siblings, 1 reply; 6+ messages in thread
From: Julien Grall @ 2023-01-31 11:42 UTC (permalink / raw)
  To: Oleksii Kurochko, xen-devel
  Cc: Jan Beulich, Andrew Cooper, Stefano Stabellini, Gianluca Guida,
	Bob Eshleman, Alistair Francis, Connor Davis, Bobby Eshleman

Hi Oleksii,

On 31/01/2023 11:17, Oleksii Kurochko wrote:
> Because printk() relies on a serial driver (like the ns16550 driver)
> and drivers require working virtual memory (ioremap()) there is not
> print functionality early in Xen boot.
> 
> The patch introduces the basic stuff of early_printk functionality
> which will be enough to print 'hello from C environment".
> 
> Originally early_printk.{c,h} was introduced by Bobby Eshleman
> (https://github.com/glg-rv/xen/commit/a3c9916bbdff7ad6030055bbee7e53d1aab71384)
> but some functionality was changed:
> early_printk() function was changed in comparison with the original as
> common isn't being built now so there is no vscnprintf.
> 
> This commit adds early printk implementation built on the putc SBI call.
> 
> As sbi_console_putchar() is already being planned for deprecation
> it is used temporarily now and will be removed or reworked after
> real uart will be ready.
> 
> Signed-off-by: Bobby Eshleman <bobby.eshleman@gmail.com>
> Signed-off-by: Oleksii Kurochko <oleksii.kurochko@gmail.com>
> Reviewed-by: Bobby Eshleman <bobby.eshleman@gmail.com>
> ---
> Changes in V8:
>      - Nothing was changed
> ---
> Changes in V7:
>      - Nothing was changed
> ---
> Changes in V6:
>      - Remove __riscv_cmodel_medany check from early_printk.c

This discussion is still not resolved. I will echo Jan's point [1] and 
expand it. There is limited point to keep sending a new version for 
small changes if there main open points are not addressed.

Can you please look at settling done on the issues first and then send a 
new version?

Cheers,

[1] 1d63dd9a-77df-4fca-e35b-886ba19fb35d@suse.com

-- 
Julien Grall


^ permalink raw reply	[flat|nested] 6+ messages in thread

* Re: [PATCH v8 1/2] xen/riscv: introduce early_printk basic stuff
  2023-01-31 11:42   ` Julien Grall
@ 2023-01-31 12:37     ` Oleksii
  2023-02-07 11:28       ` Oleksii
  0 siblings, 1 reply; 6+ messages in thread
From: Oleksii @ 2023-01-31 12:37 UTC (permalink / raw)
  To: Julien Grall, xen-devel
  Cc: Jan Beulich, Andrew Cooper, Stefano Stabellini, Gianluca Guida,
	Bob Eshleman, Alistair Francis, Connor Davis, Bobby Eshleman

Hi Julien,

On Tue, 2023-01-31 at 11:42 +0000, Julien Grall wrote:
> Hi Oleksii,
> 
> On 31/01/2023 11:17, Oleksii Kurochko wrote:
> > Because printk() relies on a serial driver (like the ns16550
> > driver)
> > and drivers require working virtual memory (ioremap()) there is not
> > print functionality early in Xen boot.
> > 
> > The patch introduces the basic stuff of early_printk functionality
> > which will be enough to print 'hello from C environment".
> > 
> > Originally early_printk.{c,h} was introduced by Bobby Eshleman
> > (
> > https://github.com/glg-rv/xen/commit/a3c9916bbdff7ad6030055bbee7e53d
> > 1aab71384)
> > but some functionality was changed:
> > early_printk() function was changed in comparison with the original
> > as
> > common isn't being built now so there is no vscnprintf.
> > 
> > This commit adds early printk implementation built on the putc SBI
> > call.
> > 
> > As sbi_console_putchar() is already being planned for deprecation
> > it is used temporarily now and will be removed or reworked after
> > real uart will be ready.
> > 
> > Signed-off-by: Bobby Eshleman <bobby.eshleman@gmail.com>
> > Signed-off-by: Oleksii Kurochko <oleksii.kurochko@gmail.com>
> > Reviewed-by: Bobby Eshleman <bobby.eshleman@gmail.com>
> > ---
> > Changes in V8:
> >      - Nothing was changed
> > ---
> > Changes in V7:
> >      - Nothing was changed
> > ---
> > Changes in V6:
> >      - Remove __riscv_cmodel_medany check from early_printk.c
> 
> This discussion is still not resolved. I will echo Jan's point [1]
> and 
> expand it. There is limited point to keep sending a new version for 
> small changes if there main open points are not addressed.
> 
> Can you please look at settling done on the issues first and then
> send a 
> new version?
Sure, I won't provide new patch series until the issue will be
resolved.

This patch series has been sent to resolve an issue with CI&CD which I
missed after the renaming of task for RISC-V in build.yaml.

~ Oleksii
> 
> Cheers,
> 
> [1] 1d63dd9a-77df-4fca-e35b-886ba19fb35d@suse.com
> 



^ permalink raw reply	[flat|nested] 6+ messages in thread

* Re: [PATCH v8 1/2] xen/riscv: introduce early_printk basic stuff
  2023-01-31 12:37     ` Oleksii
@ 2023-02-07 11:28       ` Oleksii
  0 siblings, 0 replies; 6+ messages in thread
From: Oleksii @ 2023-02-07 11:28 UTC (permalink / raw)
  To: Julien Grall, xen-devel
  Cc: Jan Beulich, Andrew Cooper, Stefano Stabellini, Gianluca Guida,
	Bob Eshleman, Alistair Francis, Connor Davis, Bobby Eshleman

On Tue, 2023-01-31 at 14:37 +0200, Oleksii wrote:
> Hi Julien,
> 
> On Tue, 2023-01-31 at 11:42 +0000, Julien Grall wrote:
> > Hi Oleksii,
> > 
> > On 31/01/2023 11:17, Oleksii Kurochko wrote:
> > > Because printk() relies on a serial driver (like the ns16550
> > > driver)
> > > and drivers require working virtual memory (ioremap()) there is
> > > not
> > > print functionality early in Xen boot.
> > > 
> > > The patch introduces the basic stuff of early_printk
> > > functionality
> > > which will be enough to print 'hello from C environment".
> > > 
> > > Originally early_printk.{c,h} was introduced by Bobby Eshleman
> > > (
> > > https://github.com/glg-rv/xen/commit/a3c9916bbdff7ad6030055bbee7e53d
> > > 1aab71384)
> > > but some functionality was changed:
> > > early_printk() function was changed in comparison with the
> > > original
> > > as
> > > common isn't being built now so there is no vscnprintf.
> > > 
> > > This commit adds early printk implementation built on the putc
> > > SBI
> > > call.
> > > 
> > > As sbi_console_putchar() is already being planned for deprecation
> > > it is used temporarily now and will be removed or reworked after
> > > real uart will be ready.
> > > 
> > > Signed-off-by: Bobby Eshleman <bobby.eshleman@gmail.com>
> > > Signed-off-by: Oleksii Kurochko <oleksii.kurochko@gmail.com>
> > > Reviewed-by: Bobby Eshleman <bobby.eshleman@gmail.com>
> > > ---
> > > Changes in V8:
> > >      - Nothing was changed
> > > ---
> > > Changes in V7:
> > >      - Nothing was changed
> > > ---
> > > Changes in V6:
> > >      - Remove __riscv_cmodel_medany check from early_printk.c
> > 
> > This discussion is still not resolved. I will echo Jan's point [1]
> > and 
> > expand it. There is limited point to keep sending a new version for
> > small changes if there main open points are not addressed.
> > 
> > Can you please look at settling done on the issues first and then
> > send a 
> > new version?
> Sure, I won't provide new patch series until the issue will be
> resolved.
> 
Since Alistair and Bobby agreed that the check is needed I'll send a
new version of the patch series.

> This patch series has been sent to resolve an issue with CI&CD which
> I
> missed after the renaming of task for RISC-V in build.yaml.
> 
> ~ Oleksii
> > 
> > Cheers,
> > 
> > [1] 1d63dd9a-77df-4fca-e35b-886ba19fb35d@suse.com
> > 
> 
~ Oleksii



^ permalink raw reply	[flat|nested] 6+ messages in thread

end of thread, other threads:[~2023-02-07 11:29 UTC | newest]

Thread overview: 6+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2023-01-31 11:17 [PATCH v8 0/2] Basic early_printk and smoke test implementation Oleksii Kurochko
2023-01-31 11:17 ` [PATCH v8 1/2] xen/riscv: introduce early_printk basic stuff Oleksii Kurochko
2023-01-31 11:42   ` Julien Grall
2023-01-31 12:37     ` Oleksii
2023-02-07 11:28       ` Oleksii
2023-01-31 11:17 ` [PATCH v8 2/2] automation: update RISC-V smoke test Oleksii Kurochko

This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.